/* ash3d.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int ash3d_c(doublereal *a, doublereal *b, doublereal *x,
        integer *n, integer *p, integer *ir, doublereal *r__, integer *ierr)
{
    /* System generated locals */
    integer i__1, i__2;
    real r__1;

    /* Local variables */
    static integer idet;
    static doublereal save, zero;
    extern /* Subroutine */ int afh3d_c(doublereal *, integer *, integer *,
            doublereal *, integer *);
    static integer i__, j, k, l, i1, n0, n1, nn, jx, nn1;

    /* Parameter adjustments */
    --a;
    --r__;
    --x;
    --b;
    --ir;

    /* Function Body */
    *ierr = 0;
    n1 = *n + 1;
    zero = 0.;
    if (*p != 1) {
        goto L1;
    }
    afh3d_c(&a[1], n, &ir[1], &r__[1], ierr);
    if (*ierr != 0) {
        goto L17;
    }
L1:
    if (*n == 1) {
        goto L7;
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        save = b[i__];
        j = ir[i__];
        b[i__] = b[j];
        b[j] = save;
/* L2: */
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L3: */
        x[i__] = b[i__];
    }
    l = 1;
    n0 = *n - 1;
    i__1 = n0;
    for (i__ = 1; i__ <= i__1; ++i__) {
        jx = l + i__;
        i1 = i__ + 1;
        l += i1;
        save = x[i__];
        if (save == zero) {
            goto L6;
        }
        if (ir[*n + i__] != 2) {
            goto L4;
        }
        jx += i1;
        ++i1;
        if (i1 > *n) {
            goto L6;
        }
L4:
        i__2 = *n;
        for (j = i1; j <= i__2; ++j) {
            x[j] -= a[jx] * save;
            jx += j;
/* L5: */
        }
L6:
        ;
    }
L7:
    l = 0;
    idet = 1;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        l += i__;
        if ((r__1 = ir[*n + i__] - 1.f) < 0.f) {
            goto L8;
        } else if (r__1 == 0) {
            goto L9;
        } else {
            goto L10;
        }
L8:
        x[i__] = (x[i__] * a[l - i__] - save * a[l - 1]) / r__[idet];
        ++idet;
        goto L11;
L9:
        x[i__] /= a[l];
        goto L11;
L10:
        save = x[i__];
        x[i__] = (save * a[l + i__ + 1] - x[i__ + 1] * a[l + i__]) / r__[idet]
                ;
L11:
        ;
    }
    nn = n0;
    if (ir[*n + *n] == 0) {
        --nn;
    }
    if (nn < 1) {
        goto L15;
    }
    nn1 = nn + 1;
    l = nn * nn1 / 2 + nn;
    i__1 = nn;
    for (k = 1; k <= i__1; ++k) {
        i__ = nn1 - k;
        i1 = i__ + 1;
        jx = l;
        l -= i1;
        save = x[i__];
        if (ir[*n + i__] != 2) {
            goto L12;
        }
        jx += i1;
        ++i1;
L12:
        i__2 = *n;
        for (j = i1; j <= i__2; ++j) {
            save -= a[jx] * x[j];
            jx += j;
/* L13: */
        }
        x[i__] = save;
/* L14: */
    }
L15:
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
        i__ = n1 - k;
        save = x[i__];
        j = ir[i__];
        x[i__] = x[j];
        x[j] = save;
/* L16: */
    }
L17:
    return 0;
} /* ash3d_c */
